// UDT DGSTR ( Donut R aboutdlg.h )
// aboutdlg.h : interface of the CAboutDlg class
//
/////////////////////////////////////////////////////////////////////////////
#pragma once

class CAboutDlg : public CDialogImpl<CAboutDlg>
{
public:
	enum { IDD = IDD_ABOUTBOX };
	HFONT hfontLink;
	HCURSOR	hCursorFinger;
	static TCHAR s_szIEVersion[MAX_PATH]; // UDT RAPT
// method
	void SetInformation(void)
	{
		TCHAR szDonutVersion[] = _T("RAPT #18f e002"); // UDT RAPT
		TCHAR szDisplayVersion[MAX_PATH] = _T("");
		DWORD dwCount = MAX_PATH * sizeof(TCHAR);
		
		// Get IE Version
		CRegKey rk;
		LONG lRet = rk.Open(HKEY_LOCAL_MACHINE,
			_T("SOFTWARE\\Microsoft\\Internet Explorer"), KEY_QUERY_VALUE);
		if (lRet == ERROR_SUCCESS )
			rk.QueryValue(s_szIEVersion, _T("Version"), &dwCount);
		else
			lstrcpy(s_szIEVersion, _T("unknown"));
		rk.Close();
		
		wsprintf(szDisplayVersion, _T("Version : %s\r\nIE : %s"), szDonutVersion, s_szIEVersion);
		SetDlgItemText(IDC_EDIT_INFORMATION, szDisplayVersion);
	}

	HCURSOR GetFingerCursor(void)
	{
		HINSTANCE	hInstHelp;
		HCURSOR		hCursor;
		char		WinDir[MAX_PATH];

		GetWindowsDirectory(WinDir,MAX_PATH-12);
		lstrcat(WinDir,"\\winhlp32.exe");
		hInstHelp = LoadLibrary(WinDir);
		if(!hInstHelp)
		{
			hCursor = LoadCursor(NULL,IDC_ARROW);
		}
		else
		{
			hCursor = CopyCursor(LoadCursor(hInstHelp,MAKEINTRESOURCE(106)));
			FreeLibrary(hInstHelp);
		}
		return hCursor;
	}

	BEGIN_MSG_MAP(CAboutDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnCtlColor) 
		MESSAGE_HANDLER(WM_SETCURSOR, OnSetCursor)
		COMMAND_ID_HANDLER(IDC_HOMEPAGE, OnHomePageCmd) 
		COMMAND_ID_HANDLER(IDOK, OnCloseCmd)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
	END_MSG_MAP()

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		CenterWindow(GetParent());
		LOGFONT logfont;	
		hfontLink = (HFONT)SendMessage(WM_GETFONT, 0, 0);
		GetObject(hfontLink, sizeof(LOGFONT), &logfont);
		logfont.lfUnderline = 1;
		hfontLink = CreateFontIndirect(&logfont);
		SendDlgItemMessage(IDC_HOMEPAGE, WM_SETFONT, (WPARAM)hfontLink, 0);
		
		hCursorFinger = GetFingerCursor();

		SetInformation();
		return TRUE;
	}

	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& bHandled)
	{
		if ( ::GetAsyncKeyState(VK_CONTROL) & 0x8000 )
		{
			OnHomePageCmd(0, wID, 0, bHandled);
				return 0;
		}
		if (hfontLink)
			DeleteObject(hfontLink);
		if (hCursorFinger)
			DestroyCursor(hCursorFinger);
		EndDialog(wID);
		return 0;
	}

	LRESULT OnCtlColor(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/) // UDT DGSTR
	{
		int id; HDC hdc;
		hdc = (HDC)wParam;
		id = ::GetDlgCtrlID((HWND)lParam);
		if(id == IDC_HOMEPAGE)
			SetTextColor(hdc, RGB(0,0,255));
		SetBkMode(hdc, TRANSPARENT);

		return (int)GetSysColorBrush(COLOR_3DFACE);
	}
	LRESULT OnSetCursor(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled) // UDT DGSTR
	{
		if((HWND)wParam == GetDlgItem(IDC_HOMEPAGE))
		{
			SetCursor(hCursorFinger);
			return TRUE;
		}
		bHandled = FALSE;
			return FALSE;
	}
	LRESULT OnHomePageCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/) // UDT DGSTR
	{
		if (hfontLink)
			DeleteObject(hfontLink);
		if (hCursorFinger)
			DestroyCursor(hCursorFinger);
		int nLen = MAX_PATH;
		LPTSTR lpszURL = (LPTSTR)_alloca((nLen+1) * sizeof(TCHAR));

		GetDlgItemText(IDC_HOMEPAGE, lpszURL, nLen);
		
		EndDialog(wID);
		DonutOpenFile(::GetParent(m_hWnd), lpszURL, DonutGetStdOpenCreateFlag());
		return 0;
	}

};

TCHAR CAboutDlg::s_szIEVersion[MAX_PATH]; // UDT RAPT


/////////////////////////////////////////////////////////////////////////////